/*
    Automatically generated from parameter files shipped with
    the RNAstructure program package.

    See also http://rna.urmc.rochester.edu/NNDB/index.html for
    a detailed description of the parameters we use here.

    (c) Ronny Lorenz 2016
*/

/*
     Current free energy parameters are summarized in:

     D.H. Turner and D.H Mathews
     "NNDB: the nearest neighbor parameter database for predicting stability of
      nucleic acid secondary structure"
     Nucleic Acids Res. 2010 Jan; 38(Database issue): D280-D282.

     D.H. Mathews, M.D. Disney, J.L. Childs, S.J. Schroeder, M. Zuker, D.H. Turner
     "Incorporating chemical modification constraints into a dynamic programming
      algorithm for prediction of RNA secondary structure"
     Proc. Natl Acad. Sci. USA. 2004; 101:7287-7292

     D.H. Mathews, J. Sabina, M. Zuker, D.H. Turner
     "Expanded sequence dependence of thermodynamic parameters improves
     prediction of RNA secondary structure"
     JMB, 288, pp 911-940, 1999

     Enthalpies taken from:

     A. Walter, D Turner, J Kim, M Lyttle, P M"uller, D Mathews, M Zuker
     "Coaxial stacking of helices enhances binding of oligoribonucleotides.."
     PNAS, 91, pp 9218-9222, 1994

     D.H. Turner, N. Sugimoto, and S.M. Freier.
     "RNA Structure Prediction",
     Ann. Rev. Biophys. Biophys. Chem. 17, 167-192, 1988.

     John A.Jaeger, Douglas H.Turner, and Michael Zuker.
     "Improved predictions of secondary structures for RNA",
     PNAS, 86, 7706-7710, October 1989.

     L. He, R. Kierzek, J. SantaLucia, A.E. Walter, D.H. Turner
     "Nearest-Neighbor Parameters for GU Mismatches...."
     Biochemistry 1991, 30 11124-11132

     A.E. Peritz, R. Kierzek, N, Sugimoto, D.H. Turner
     "Thermodynamic Study of Internal Loops in Oligoribonucleotides..."
     Biochemistry 1991, 30, 6428--6435
*/

/* RNAfold parameters v2.x */
/* DNA parameters */


#include "ViennaRNA/energy_const.h"

#define NST 0     /* Energy for nonstandard stacked pairs */
#define DEF -50   /* Default terminal mismatch, used for I */
                  /* and any non_pairing bases */
#define NSM 0     /* terminal mismatch for non standard pairs */

#define PUBLIC

PUBLIC double lxc37_D     = 107.90;
PUBLIC double lxcdH_D     = 100.00;
PUBLIC int ML_intern37_D  =     20;
PUBLIC int ML_interndH_D  =      0;
PUBLIC int ML_closing37_D =    300;
PUBLIC int ML_closingdH_D =    900;
PUBLIC int ML_BASE37_D    =     20;
PUBLIC int ML_BASEdH_D    =      0;
PUBLIC int MAX_NINIO_D    =    300;
PUBLIC int ninio37_D      =     40;
PUBLIC int niniodH_D      =      0;
PUBLIC int TerminalAU37_D =      0;
PUBLIC int TerminalAUdH_D =    320;
PUBLIC int DuplexInit37_D =    100;
PUBLIC int DuplexInitdH_D =   -720;

PUBLIC int TripleC37_D    =      0;
PUBLIC int TripleCdH_D    =      0;
PUBLIC int MultipleCA37_D =      0;
PUBLIC int MultipleCAdH_D =      0;
PUBLIC int MultipleCB37_D =      0;
PUBLIC int MultipleCBdH_D =      0;

PUBLIC int GQuadAlpha37_D = -1800;
PUBLIC int GQuadAlphadH_D = -11934;
PUBLIC int GQuadBeta37_D  = 1200;
PUBLIC int GQuadBetadH_D  = 0;
PUBLIC int stack37_D[NBPAIRS+1][NBPAIRS+1] = 
/*     NP      CG      GC      GT      TG      AT      TA      NN        */
{{    INF,    INF,    INF,    INF,    INF,    INF,    INF,    INF} /* NP */
,{    INF,   -220,   -180,    -30,    -50,   -130,   -150,    -30} /* CG */
,{    INF,   -180,   -220,    -60,     10,   -140,   -130,     10} /* GC */
,{    INF,    -30,    -60,    120,     70,     10,     30,    120} /* GT */
,{    INF,    -50,     10,     70,     50,     70,     40,     70} /* TG */
,{    INF,   -130,   -140,     10,     70,    -90,   -100,     70} /* AT */
,{    INF,   -150,   -130,     30,     40,   -100,    -60,     40} /* TA */
,{    INF,    -30,     10,    120,     70,     70,     40,    120} /* NN */
};
PUBLIC int stackdH_D[NBPAIRS+1][NBPAIRS+1] = 
/*     NP      CG      GC      GT      TG      AT      TA      NN        */
{{    INF,    INF,    INF,    INF,    INF,    INF,    INF,    INF} /* NP */
,{    INF,   -980,   -750,   -240,   -430,   -580,   -990,   -240} /* CG */
,{    INF,   -750,   -790,   -240,    430,   -780,   -850,    430} /* GC */
,{    INF,   -240,   -240,    500,    800,   -170,    -90,    800} /* GT */
,{    INF,   -430,    430,    800,   -670,    340,    -90,    800} /* TG */
,{    INF,   -580,   -780,   -170,    370,   -530,   -720,    370} /* AT */
,{    INF,   -990,   -850,    -90,    -90,   -720,   -670,    -90} /* TA */
,{    INF,   -240,    430,    800,    800,    340,    -90,    800} /* NN */
};
PUBLIC int hairpin37_D[31] = {   INF,   INF,   INF,    340,    340,    350,    420,    420,    420,    430,    440,    450,    460,    470,    480,    500,    510,    520,    530,    540,    550,    560,    570,    580,    590,    600,    610,    620,    630,    640,    650};
PUBLIC int hairpindH_D[31] = {   INF,   INF,   INF,    -60,   -230,  -1210,  -1670,  -1360,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410};
PUBLIC int bulge37_D[31] = {   INF,    290,    230,    250,    270,    300,    320,    340,    350,    360,    370,    390,    390,    400,    410,    420,    430,    430,    440,    440,    450,    450,    460,    460,    470,    470,    470,    480,    490,    490,    490};
PUBLIC int bulgedH_D[31] = {   INF,   1890,    -60,   -230,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410,  -1410};
PUBLIC int internal_loop37_D[31] = {   INF,   INF,   INF,   INF,    310,    350,    390,    410,    420,    430,    450,    460,    460,    470,    480,    490,    500,    500,    510,    510,    520,    530,    530,    530,    540,    540,    550,    550,    560,    560,    560};
PUBLIC int internal_loopdH_D[31] = {   INF,   INF,   INF,   INF,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0};
PUBLIC int mismatchI37_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -80,    -90,      0} /* A */
 ,{      0,    -80,    -50,      0,    -70} /* C */
 ,{      0,   -100,      0,    -90,   -100} /* G */
 ,{      0,      0,    -60,    -90,    -90} /* T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -70,    -80,      0} /* A */
 ,{      0,   -100,    -60,      0,    -70} /* C */
 ,{      0,   -100,      0,   -100,    -80} /* G */
 ,{      0,      0,    -60,    -90,    -90} /* T */
 }
,/* GT */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -60} /* A */
 ,{    -20,    -20,    -20,    -90,    -20} /* C */
 ,{    -50,    -50,    -90,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* TG */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -50} /* A */
 ,{    -20,    -20,    -20,    -80,    -20} /* C */
 ,{    -50,    -50,   -100,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* AT */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -70,    -30,    -50,      0} /* A */
 ,{      0,    -60,    -20,      0,    -30} /* C */
 ,{      0,    -60,      0,    -40,    -50} /* G */
 ,{      0,      0,    -30,    -50,    -40} /* T */
 }
,/* TA */
 {{      0,      0,     -0,      0,      0} /* E */
 ,{      0,    -60,    -40,    -50,      0} /* A */
 ,{      0,    -50,    -20,      0,    -50} /* C */
 ,{     -0,    -60,     -0,    -40,    -50} /* G */
 ,{      0,      0,    -30,    -60,    -30} /* T */
 }
,/* NN */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -20,    -50,      0} /* A */
 ,{      0,    -20,    -20,      0,    -20} /* C */
 ,{      0,    -50,      0,    -40,    -50} /* G */
 ,{      0,      0,    -20,    -50,    -20} /* T */
 }
};
PUBLIC int mismatchIdH_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{   -420,   -460,   -420,   -470,   -500} /* E */
 ,{   -420,   -460,   -420,   -470,   -500} /* A */
 ,{   -420,   -460,   -420,   -470,   -500} /* C */
 ,{   -420,   -460,   -420,   -470,   -500} /* G */
 ,{   -420,   -460,   -420,   -470,   -500} /* T */
 }
,/* GC */
 {{    -90,   -620,   -330,   -510,    -90} /* E */
 ,{    -90,   -620,   -330,   -510,    -90} /* A */
 ,{    -90,   -620,   -330,   -510,    -90} /* C */
 ,{    -90,   -620,   -330,   -510,    -90} /* G */
 ,{    -90,   -620,   -330,   -510,    -90} /* T */
 }
,/* GT */
 {{    230,   -300,    -10,   -190,    230} /* E */
 ,{    230,   -300,    -10,   -190,    230} /* A */
 ,{    230,   -300,    -10,   -190,    230} /* C */
 ,{    230,   -300,    -10,   -190,    230} /* G */
 ,{    230,   -300,    -10,   -190,    230} /* T */
 }
,/* TG */
 {{    230,    230,    170,     70,   -580} /* E */
 ,{    230,    230,    170,     70,   -580} /* A */
 ,{    230,    230,    170,     70,   -580} /* C */
 ,{    230,    230,    170,     70,   -580} /* G */
 ,{    230,    230,    170,     70,   -580} /* T */
 }
,/* AT */
 {{    520,    400,    520,    470,    430} /* E */
 ,{    520,    400,    520,    470,    430} /* A */
 ,{    520,    400,    520,    470,    430} /* C */
 ,{    520,    400,    520,    470,    430} /* G */
 ,{    520,    400,    520,    470,    430} /* T */
 }
,/* TA */
 {{    230,    230,    170,     70,   -580} /* E */
 ,{    230,    230,    170,     70,   -580} /* A */
 ,{    230,    230,    170,     70,   -580} /* C */
 ,{    230,    230,    170,     70,   -580} /* G */
 ,{    230,    230,    170,     70,   -580} /* T */
 }
,/* NN */
 {{    520,    400,    520,    470,    430} /* E */
 ,{    520,    400,    520,    470,    430} /* A */
 ,{    520,    400,    520,    470,    430} /* C */
 ,{    520,    400,    520,    470,    430} /* G */
 ,{    520,    400,    520,    470,    430} /* T */
 }
};
PUBLIC int mismatchH37_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -80,    -90,      0} /* A */
 ,{      0,    -80,    -50,      0,    -70} /* C */
 ,{      0,   -100,      0,    -90,   -100} /* G */
 ,{      0,      0,    -60,    -90,    -90} /* T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -70,    -80,      0} /* A */
 ,{      0,   -100,    -60,      0,    -70} /* C */
 ,{      0,   -100,      0,   -100,    -80} /* G */
 ,{      0,      0,    -60,    -90,    -90} /* T */
 }
,/* GT */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -60} /* A */
 ,{    -20,    -20,    -20,    -90,    -20} /* C */
 ,{    -50,    -50,    -90,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* TG */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -50} /* A */
 ,{    -20,    -20,    -20,    -80,    -20} /* C */
 ,{    -50,    -50,   -100,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* AT */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -70,    -30,    -50,      0} /* A */
 ,{      0,    -60,    -20,      0,    -30} /* C */
 ,{      0,    -60,      0,    -40,    -50} /* G */
 ,{      0,      0,    -30,    -50,    -40} /* T */
 }
,/* TA */
 {{      0,      0,     -0,      0,      0} /* E */
 ,{      0,    -60,    -40,    -50,      0} /* A */
 ,{      0,    -50,    -20,      0,    -50} /* C */
 ,{     -0,    -60,     -0,    -40,    -50} /* G */
 ,{      0,      0,    -30,    -60,    -30} /* T */
 }
,/* NN */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -20,    -50,      0} /* A */
 ,{      0,    -20,    -20,      0,    -20} /* C */
 ,{      0,    -50,      0,    -40,    -50} /* G */
 ,{      0,      0,    -20,    -50,    -20} /* T */
 }
};
PUBLIC int mismatchHdH_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{   -420,   -460,   -420,   -470,   -500} /* E */
 ,{   -420,   -460,   -420,   -470,   -500} /* A */
 ,{   -420,   -460,   -420,   -470,   -500} /* C */
 ,{   -420,   -460,   -420,   -470,   -500} /* G */
 ,{   -420,   -460,   -420,   -470,   -500} /* T */
 }
,/* GC */
 {{    -90,   -620,   -330,   -510,    -90} /* E */
 ,{    -90,   -620,   -330,   -510,    -90} /* A */
 ,{    -90,   -620,   -330,   -510,    -90} /* C */
 ,{    -90,   -620,   -330,   -510,    -90} /* G */
 ,{    -90,   -620,   -330,   -510,    -90} /* T */
 }
,/* GT */
 {{    230,   -300,    -10,   -190,    230} /* E */
 ,{    230,   -300,    -10,   -190,    230} /* A */
 ,{    230,   -300,    -10,   -190,    230} /* C */
 ,{    230,   -300,    -10,   -190,    230} /* G */
 ,{    230,   -300,    -10,   -190,    230} /* T */
 }
,/* TG */
 {{    230,    230,    170,     70,   -580} /* E */
 ,{    230,    230,    170,     70,   -580} /* A */
 ,{    230,    230,    170,     70,   -580} /* C */
 ,{    230,    230,    170,     70,   -580} /* G */
 ,{    230,    230,    170,     70,   -580} /* T */
 }
,/* AT */
 {{    520,    400,    520,    470,    430} /* E */
 ,{    520,    400,    520,    470,    430} /* A */
 ,{    520,    400,    520,    470,    430} /* C */
 ,{    520,    400,    520,    470,    430} /* G */
 ,{    520,    400,    520,    470,    430} /* T */
 }
,/* TA */
 {{    230,    230,    170,     70,   -580} /* E */
 ,{    230,    230,    170,     70,   -580} /* A */
 ,{    230,    230,    170,     70,   -580} /* C */
 ,{    230,    230,    170,     70,   -580} /* G */
 ,{    230,    230,    170,     70,   -580} /* T */
 }
,/* NN */
 {{    520,    400,    520,    470,    430} /* E */
 ,{    520,    400,    520,    470,    430} /* A */
 ,{    520,    400,    520,    470,    430} /* C */
 ,{    520,    400,    520,    470,    430} /* G */
 ,{    520,    400,    520,    470,    430} /* T */
 }
};
PUBLIC int mismatchM37_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,   -100,   -100,      0} /* A */
 ,{      0,    -70,    -60,      0,    -60} /* C */
 ,{      0,    -80,      0,   -100,    -90} /* G */
 ,{      0,      0,    -70,    -80,    -90} /* T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -80,   -100,      0} /* A */
 ,{      0,    -80,    -50,      0,    -60} /* C */
 ,{      0,    -90,      0,    -90,    -90} /* G */
 ,{      0,      0,    -70,   -100,    -90} /* T */
 }
,/* GT */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -50} /* A */
 ,{    -20,    -20,    -20,   -100,    -20} /* C */
 ,{    -50,    -50,    -80,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* TG */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -50} /* A */
 ,{    -20,    -20,    -20,    -90,    -20} /* C */
 ,{    -50,    -50,    -90,    -50,    -50} /* G */
 ,{    -20,    -60,    -20,    -50,    -20} /* T */
 }
,/* AT */
 {{      0,      0,      0,     -0,      0} /* E */
 ,{      0,    -60,    -50,    -60,      0} /* A */
 ,{     -0,    -40,    -20,     -0,    -30} /* C */
 ,{      0,    -50,      0,    -40,    -60} /* G */
 ,{      0,      0,    -50,    -50,    -30} /* T */
 }
,/* TA */
 {{      0,     -0,      0,      0,      0} /* E */
 ,{      0,    -70,    -60,    -60,      0} /* A */
 ,{      0,    -30,    -20,      0,    -30} /* C */
 ,{      0,    -50,      0,    -40,    -50} /* G */
 ,{      0,     -0,    -30,    -50,    -40} /* T */
 }
,/* NN */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -20,    -50,      0} /* A */
 ,{      0,    -20,    -20,      0,    -20} /* C */
 ,{      0,    -50,      0,    -40,    -50} /* G */
 ,{      0,      0,    -20,    -50,    -20} /* T */
 }
};
PUBLIC int mismatchMdH_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{    -90,    -90,    -90,    -90,    -90} /* E */
 ,{   -620,   -620,   -620,   -620,   -620} /* A */
 ,{   -330,   -330,   -330,   -330,   -330} /* C */
 ,{   -510,   -510,   -510,   -510,   -510} /* G */
 ,{    -90,    -90,    -90,    -90,    -90} /* T */
 }
,/* GC */
 {{   -420,   -420,   -420,   -420,   -420} /* E */
 ,{   -460,   -460,   -460,   -460,   -460} /* A */
 ,{   -420,   -420,   -420,   -420,   -420} /* C */
 ,{   -470,   -470,   -470,   -470,   -470} /* G */
 ,{   -500,   -500,   -500,   -500,   -500} /* T */
 }
,/* GT */
 {{    230,    230,    230,    230,    230} /* E */
 ,{    230,    230,    230,    230,    230} /* A */
 ,{    170,    170,    170,    170,    170} /* C */
 ,{     70,     70,     70,     70,     70} /* G */
 ,{   -580,   -580,   -580,   -580,   -580} /* T */
 }
,/* TG */
 {{    230,    230,    230,    230,    230} /* E */
 ,{   -300,   -300,   -300,   -300,   -300} /* A */
 ,{    -10,    -10,    -10,    -10,    -10} /* C */
 ,{   -190,   -190,   -190,   -190,   -190} /* G */
 ,{    230,    230,    230,    230,    230} /* T */
 }
,/* AT */
 {{    230,    230,    230,    230,    230} /* E */
 ,{    230,    230,    230,    230,    230} /* A */
 ,{    170,    170,    170,    170,    170} /* C */
 ,{     70,     70,     70,     70,     70} /* G */
 ,{   -580,   -580,   -580,   -580,   -580} /* T */
 }
,/* TA */
 {{    520,    520,    520,    520,    520} /* E */
 ,{    400,    400,    400,    400,    400} /* A */
 ,{    520,    520,    520,    520,    520} /* C */
 ,{    470,    470,    470,    470,    470} /* G */
 ,{    430,    430,    430,    430,    430} /* T */
 }
,/* NN */
 {{    520,    520,    520,    520,    520} /* E */
 ,{    400,    400,    400,    400,    400} /* A */
 ,{    520,    520,    520,    520,    520} /* C */
 ,{    470,    470,    470,    470,    470} /* G */
 ,{    430,    430,    430,    430,    430} /* T */
 }
};
PUBLIC int mismatch1nI37_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* GT */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* TG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* AT */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* TA */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* NN */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
};
PUBLIC int mismatch1nIdH_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* T */
 }
,/* GT */
 {{    320,    320,    320,    320,    320} /* E */
 ,{    320,    320,    320,    320,    320} /* A */
 ,{    320,    320,    320,    320,    320} /* C */
 ,{    320,    320,    320,    320,    320} /* G */
 ,{    320,    320,    320,    320,    320} /* T */
 }
,/* TG */
 {{    320,    320,    320,    320,    320} /* E */
 ,{    320,    320,    320,    320,    320} /* A */
 ,{    320,    320,    320,    320,    320} /* C */
 ,{    320,    320,    320,    320,    320} /* G */
 ,{    320,    320,    320,    320,    320} /* T */
 }
,/* AT */
 {{    320,    320,    320,    320,    320} /* E */
 ,{    320,    320,    320,    320,    320} /* A */
 ,{    320,    320,    320,    320,    320} /* C */
 ,{    320,    320,    320,    320,    320} /* G */
 ,{    320,    320,    320,    320,    320} /* T */
 }
,/* TA */
 {{    320,    320,    320,    320,    320} /* E */
 ,{    320,    320,    320,    320,    320} /* A */
 ,{    320,    320,    320,    320,    320} /* C */
 ,{    320,    320,    320,    320,    320} /* G */
 ,{    320,    320,    320,    320,    320} /* T */
 }
,/* NN */
 {{    320,    320,    320,    320,    320} /* E */
 ,{    320,    320,    320,    320,    320} /* A */
 ,{    320,    320,    320,    320,    320} /* C */
 ,{    320,    320,    320,    320,    320} /* G */
 ,{    320,    320,    320,    320,    320} /* T */
 }
};
PUBLIC int mismatch23I37_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -80,    -90,      0} /* A */
 ,{      0,    -80,    -50,      0,    -70} /* C */
 ,{      0,   -100,      0,    -90,   -100} /* G */
 ,{      0,      0,    -60,    -90,    -90} /* T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -70,    -80,      0} /* A */
 ,{      0,   -100,    -60,      0,    -70} /* C */
 ,{      0,   -100,      0,   -100,    -80} /* G */
 ,{      0,      0,    -60,    -90,    -90} /* T */
 }
,/* GT */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -60} /* A */
 ,{    -20,    -20,    -20,    -90,    -20} /* C */
 ,{    -50,    -50,    -90,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* TG */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -50} /* A */
 ,{    -20,    -20,    -20,    -80,    -20} /* C */
 ,{    -50,    -50,   -100,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* AT */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -70,    -30,    -50,      0} /* A */
 ,{      0,    -60,    -20,      0,    -30} /* C */
 ,{      0,    -60,      0,    -40,    -50} /* G */
 ,{      0,      0,    -30,    -50,    -40} /* T */
 }
,/* TA */
 {{      0,      0,     -0,      0,      0} /* E */
 ,{      0,    -60,    -40,    -50,      0} /* A */
 ,{      0,    -50,    -20,      0,    -50} /* C */
 ,{     -0,    -60,     -0,    -40,    -50} /* G */
 ,{      0,      0,    -30,    -60,    -30} /* T */
 }
,/* NN */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -20,    -50,      0} /* A */
 ,{      0,    -20,    -20,      0,    -20} /* C */
 ,{      0,    -50,      0,    -40,    -50} /* G */
 ,{      0,      0,    -20,    -50,    -20} /* T */
 }
};
PUBLIC int mismatch23IdH_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{   -420,   -460,   -420,   -470,   -500} /* E */
 ,{   -420,   -460,   -420,   -470,   -500} /* A */
 ,{   -420,   -460,   -420,   -470,   -500} /* C */
 ,{   -420,   -460,   -420,   -470,   -500} /* G */
 ,{   -420,   -460,   -420,   -470,   -500} /* T */
 }
,/* GC */
 {{    -90,   -620,   -330,   -510,    -90} /* E */
 ,{    -90,   -620,   -330,   -510,    -90} /* A */
 ,{    -90,   -620,   -330,   -510,    -90} /* C */
 ,{    -90,   -620,   -330,   -510,    -90} /* G */
 ,{    -90,   -620,   -330,   -510,    -90} /* T */
 }
,/* GT */
 {{    230,   -300,    -10,   -190,    230} /* E */
 ,{    230,   -300,    -10,   -190,    230} /* A */
 ,{    230,   -300,    -10,   -190,    230} /* C */
 ,{    230,   -300,    -10,   -190,    230} /* G */
 ,{    230,   -300,    -10,   -190,    230} /* T */
 }
,/* TG */
 {{    230,    230,    170,     70,   -580} /* E */
 ,{    230,    230,    170,     70,   -580} /* A */
 ,{    230,    230,    170,     70,   -580} /* C */
 ,{    230,    230,    170,     70,   -580} /* G */
 ,{    230,    230,    170,     70,   -580} /* T */
 }
,/* AT */
 {{    520,    400,    520,    470,    430} /* E */
 ,{    520,    400,    520,    470,    430} /* A */
 ,{    520,    400,    520,    470,    430} /* C */
 ,{    520,    400,    520,    470,    430} /* G */
 ,{    520,    400,    520,    470,    430} /* T */
 }
,/* TA */
 {{    230,    230,    170,     70,   -580} /* E */
 ,{    230,    230,    170,     70,   -580} /* A */
 ,{    230,    230,    170,     70,   -580} /* C */
 ,{    230,    230,    170,     70,   -580} /* G */
 ,{    230,    230,    170,     70,   -580} /* T */
 }
,/* NN */
 {{    520,    400,    520,    470,    430} /* E */
 ,{    520,    400,    520,    470,    430} /* A */
 ,{    520,    400,    520,    470,    430} /* C */
 ,{    520,    400,    520,    470,    430} /* G */
 ,{    520,    400,    520,    470,    430} /* T */
 }
};
PUBLIC int mismatchExt37_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,   -100,   -100,      0} /* A */
 ,{      0,    -70,    -60,      0,    -60} /* C */
 ,{      0,    -80,      0,   -100,    -90} /* G */
 ,{      0,      0,    -70,    -80,    -90} /* T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,   -100,    -80,   -100,      0} /* A */
 ,{      0,    -80,    -50,      0,    -60} /* C */
 ,{      0,    -90,      0,    -90,    -90} /* G */
 ,{      0,      0,    -70,   -100,    -90} /* T */
 }
,/* GT */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -50} /* A */
 ,{    -20,    -20,    -20,   -100,    -20} /* C */
 ,{    -50,    -50,    -80,    -50,    -50} /* G */
 ,{    -20,    -50,    -20,    -50,    -20} /* T */
 }
,/* TG */
 {{    -20,    -20,    -20,    -50,    -20} /* E */
 ,{    -20,    -50,    -20,    -50,    -50} /* A */
 ,{    -20,    -20,    -20,    -90,    -20} /* C */
 ,{    -50,    -50,    -90,    -50,    -50} /* G */
 ,{    -20,    -60,    -20,    -50,    -20} /* T */
 }
,/* AT */
 {{      0,      0,      0,     -0,      0} /* E */
 ,{      0,    -60,    -50,    -60,      0} /* A */
 ,{     -0,    -40,    -20,     -0,    -30} /* C */
 ,{      0,    -50,      0,    -40,    -60} /* G */
 ,{      0,      0,    -50,    -50,    -30} /* T */
 }
,/* TA */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -70,    -60,    -60,      0} /* A */
 ,{      0,    -30,    -20,      0,    -30} /* C */
 ,{      0,    -50,      0,    -40,    -50} /* G */
 ,{      0,      0,    -30,    -50,    -40} /* T */
 }
,/* NN */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -20,    -50,      0} /* A */
 ,{      0,    -20,    -20,      0,    -20} /* C */
 ,{      0,    -50,      0,    -40,    -50} /* G */
 ,{      0,      0,    -20,    -50,    -20} /* T */
 }
};
PUBLIC int mismatchExtdH_D[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* T */
 }
,/* CG */
 {{    -90,    -90,    -90,    -90,    -90} /* E */
 ,{   -620,   -620,   -620,   -620,   -620} /* A */
 ,{   -330,   -330,   -330,   -330,   -330} /* C */
 ,{   -510,   -510,   -510,   -510,   -510} /* G */
 ,{    -90,    -90,    -90,    -90,    -90} /* T */
 }
,/* GC */
 {{   -420,   -420,   -420,   -420,   -420} /* E */
 ,{   -460,   -460,   -460,   -460,   -460} /* A */
 ,{   -420,   -420,   -420,   -420,   -420} /* C */
 ,{   -470,   -470,   -470,   -470,   -470} /* G */
 ,{   -500,   -500,   -500,   -500,   -500} /* T */
 }
,/* GT */
 {{    -60,    -60,    -60,    -60,    -60} /* E */
 ,{    -90,    -90,    -90,    -90,    -90} /* A */
 ,{    -60,    -60,    -60,    -60,    -60} /* C */
 ,{   -250,   -250,   -250,   -250,   -250} /* G */
 ,{   -900,   -900,   -900,   -900,   -900} /* T */
 }
,/* TG */
 {{    -90,    -90,    -90,    -90,    -90} /* E */
 ,{   -620,   -620,   -620,   -620,   -620} /* A */
 ,{   -330,   -330,   -330,   -330,   -330} /* C */
 ,{   -510,   -510,   -510,   -510,   -510} /* G */
 ,{    -90,    -90,    -90,    -90,    -90} /* T */
 }
,/* AT */
 {{    -60,    -60,    -60,    -60,    -60} /* E */
 ,{    -90,    -90,    -90,    -90,    -90} /* A */
 ,{    -60,    -60,    -60,    -60,    -60} /* C */
 ,{   -250,   -250,   -250,   -250,   -250} /* G */
 ,{   -900,   -900,   -900,   -900,   -900} /* T */
 }
,/* TA */
 {{    200,    200,    200,    200,    200} /* E */
 ,{     80,     80,     80,     80,     80} /* A */
 ,{    200,    200,    200,    200,    200} /* C */
 ,{    150,    150,    150,    150,    150} /* G */
 ,{    110,    110,    110,    110,    110} /* T */
 }
,/* NN */
 {{    200,    200,    200,    200,    200} /* E */
 ,{     80,     80,     80,     80,     80} /* A */
 ,{    200,    200,    200,    200,    200} /* C */
 ,{    150,    150,    150,    150,    150} /* G */
 ,{    110,    110,    110,    110,    110} /* T */
 }
};
PUBLIC int dangle5_37_D[NBPAIRS+1][5] = 
/*      E       A       C       G       T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -50,    -90,    -50,    -70,    -60} /* CG */
,{    -50,    -80,    -50,    -80,    -70} /* GC */
,{    -10,    -10,    -10,    -10,    -10} /* GT */
,{    -10,    -10,    -10,    -10,    -10} /* TG */
,{    -20,    -50,    -20,    -60,    -30} /* AT */
,{    -20,    -50,    -20,    -50,    -30} /* TA */
,{    -10,    -10,    -10,    -10,    -10} /* NN */
};
PUBLIC int dangle5_dH_D[NBPAIRS+1][5] = 
/*      E       A       C       G       T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -90,   -620,   -330,   -510,    -90} /* CG */
,{   -420,   -460,   -420,   -470,   -500} /* GC */
,{   -420,   -460,   -420,   -470,   -500} /* GT */
,{    -90,   -620,   -330,   -510,    -90} /* TG */
,{    -60,    -90,    -60,   -250,   -900} /* AT */
,{    200,     80,    200,    150,    110} /* TA */
,{    200,     80,    200,    150,    110} /* NN */
};
PUBLIC int dangle3_37_D[NBPAIRS+1][5] = 
/*      E       A       C       G       T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -20,    -40,    -20,    -40,    -30} /* CG */
,{    -40,   -110,    -40,   -110,    -80} /* GC */
,{    -20,    -20,    -20,    -20,    -20} /* GT */
,{    -20,    -20,    -20,    -20,    -20} /* TG */
,{    -20,    -20,    -20,    -20,    -20} /* AT */
,{    -20,    -20,    -20,    -20,    -20} /* TA */
,{    -20,    -20,    -20,    -20,    -20} /* NN */
};
PUBLIC int dangle3_dH_D[NBPAIRS+1][5] = 
/*      E       A       C       G       T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -20,   -190,    -20,   -400,   -550} /* CG */
,{   -250,   -800,   -250,   -310,   -390} /* GC */
,{   -250,   -800,   -250,   -310,   -390} /* GT */
,{    -20,   -190,    -20,   -400,   -550} /* TG */
,{    200,   -530,    200,   -480,     90} /* AT */
,{    630,    430,    630,    250,    260} /* TA */
,{    630,    430,    630,    250,    260} /* NN */
};
PUBLIC int Hexaloop37_D[40] = {};
PUBLIC int HexaloopdH_D[40] = {};

PUBLIC char Hexaloops_D[361] = 
  "";
PUBLIC int Tetraloop37_D[40] = {    150,    -50,    150,    -50,    150,   -100};
PUBLIC int TetraloopdH_D[40] = {  -3260,  -3890,  -2290,  -4240,  -3110,  -1530};

PUBLIC char Tetraloops_D[281] = 
  "AAAAAT "
  "ATTTTT "
  "CAAAAG "
  "CTTTTG "
  "GAAAAC "
  "GGAAAC "
  "";
PUBLIC int Triloop37_D[40] = {   -200};
PUBLIC int TriloopdH_D[40] = {  -2820};

PUBLIC char Triloops_D[241] = 
  "CGCAG "
  "";
#include "intl11_D.h"
#include "intl11dH_D.h"
#include "intl21_D.h"
#include "intl21dH_D.h"
#include "intl22_D.h"
#include "intl22dH_D.h"


